import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import { jsxs as _jsxs } from "react/jsx-runtime";
import { jsx as _jsx } from "react/jsx-runtime";

/* eslint-disable react/prop-types */
import { Component } from 'react';
import cx from 'classnames';

var DropdownUser = /*#__PURE__*/function (_Component) {
  _inheritsLoose(DropdownUser, _Component);

  function DropdownUser() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;
    _this.state = {
      expanded: false,
      collapseByTouch: false
    };

    _this._doNothing = function () {};

    _this._toggleMenu = function () {
      var expanded = _this.state.expanded;

      _this.setState({
        expanded: !expanded
      });
    };

    _this._onMouseOver = function () {
      _this.setState({
        expanded: true,
        collapseByTouch: true
      });
    };

    _this._onMouseOut = function () {
      _this.setState({
        expanded: false,
        collapseByTouch: false
      });
    };

    _this._renderLink = function (_ref, index) {
      var text = _ref.text,
          url = _ref.url,
          Icon = _ref.icon,
          notifications = _ref.notifications,
          highlight = _ref.highlight;
      var Link = _this.props.linkFactory;
      var linkClassName = cx('sui-DropdownUserMenu-listLink', {
        'sui-DropdownUserMenu-listLinkHighlight': highlight
      });
      var iconClassName = cx('sui-DropdownUserMenu-listIcon', {
        'sui-DropdownUserMenu-listIconHighlight': highlight
      });
      return /*#__PURE__*/_jsx("li", {
        className: "sui-DropdownUserMenu-listItem",
        children: /*#__PURE__*/_jsxs(Link, {
          href: url,
          className: linkClassName,
          title: text,
          children: [/*#__PURE__*/_jsx(Icon, {
            svgClass: iconClassName
          }), /*#__PURE__*/_jsx("span", {
            className: "sui-DropdownUserMenu-listText",
            children: text
          }), !!notifications && /*#__PURE__*/_jsx("span", {
            className: "sui-DropdownUserMenu-listNotification",
            children: notifications
          })]
        })
      }, text + "-" + index);
    };

    return _this;
  }

  var _proto = DropdownUser.prototype;

  _proto.render = function render() {
    var _this$state = this.state,
        expanded = _this$state.expanded,
        collapseByTouch = _this$state.collapseByTouch;
    var _this$props = this.props,
        user = _this$props.user,
        menu = _this$props.menu,
        expandOnMouseOver = _this$props.expandOnMouseOver,
        _this$props$hasNotifi = _this$props.hasNotifications,
        hasNotifications = _this$props$hasNotifi === void 0 ? this.props.menu.some(function (_ref2) {
      var notifications = _ref2.notifications;
      return Boolean(notifications);
    }) : _this$props$hasNotifi;
    var name = user.name,
        avatar = user.avatar;
    var wrapperClassName = cx('sui-DropdownUser', {
      'is-expanded': expanded,
      'has-notifications': hasNotifications
    });
    return /*#__PURE__*/_jsxs("div", {
      className: wrapperClassName,
      onMouseOver: expandOnMouseOver ? this._onMouseOver : this._doNothing,
      onMouseOut: expandOnMouseOver ? this._onMouseOut : this._doNothing,
      children: [/*#__PURE__*/_jsxs("div", {
        className: "sui-DropdownUser-button",
        onClick: expandOnMouseOver ? this._doNothing : this._toggleMenu,
        onTouchStart: expandOnMouseOver && collapseByTouch ? this._toggleMenu : this._doNothing,
        children: [/*#__PURE__*/_jsx("div", {
          className: "sui-DropdownUser-buttonAvatarWrap",
          children: /*#__PURE__*/_jsx("img", {
            className: "sui-DropdownUser-buttonAvatar",
            src: avatar,
            alt: name + "-avatar"
          })
        }), /*#__PURE__*/_jsx("span", {
          className: "sui-DropdownUser-buttonText",
          children: name
        })]
      }), /*#__PURE__*/_jsx("div", {
        className: "sui-DropdownUserMenu-wrap",
        children: /*#__PURE__*/_jsx("div", {
          className: "sui-DropdownUserMenu",
          children: /*#__PURE__*/_jsx("ul", {
            className: "sui-DropdownUserMenu-list",
            children: menu.map(this._renderLink)
          })
        })
      })]
    });
  };

  return DropdownUser;
}(Component);

DropdownUser.displayName = 'DropdownUser';
DropdownUser.defaultProps = {
  expandOnMouseOver: false,
  linkFactory: function linkFactory(_ref3) {
    var href = _ref3.href,
        className = _ref3.className,
        children = _ref3.children,
        title = _ref3.title;
    return /*#__PURE__*/_jsx("a", {
      href: href,
      className: className,
      title: title,
      children: children
    });
  }
};
export default DropdownUser;